## ycm-cmake-modules 0.12.1

=== CMakeLists.txt ===
#=============================================================================
# Copyright 2013-2014 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


cmake_minimum_required(VERSION 3.12)
project(YCM NONE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/internal-modules")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/modules")

include(YCMVersion)
include(YCMInternal)

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  option(YCM_MAINTAINER_MODE "Enable maintainer mode (download all files and enable CPack) - Latest CMake version is recommended" FALSE)
  mark_as_advanced(YCM_MAINTAINER_MODE)
endif()

if(YCM_MAINTAINER_MODE)
  if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
    message(WARNING "Cannot enable maintainer mode outside a git repository. The YCM_MAINTAINER_MODE option will be disabled.")
    unset(YCM_MAINTAINER_MODE)
    unset(YCM_MAINTAINER_MODE CACHE)
  else()
    include(YCMPack)
  endif()
endif()

include(GNUInstallDirs)

set(YCM_BUILD_MODULE_DIR "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/YCM")
set(YCM_INSTALL_MODULE_DIR "${CMAKE_INSTALL_DATADIR}/YCM")

set(YCM_BUILD_CMAKE_DIR "${CMAKE_BINARY_DIR}")
set(YCM_INSTALL_CMAKE_DIR "${CMAKE_INSTALL_DATADIR}/YCM/cmake")


# FIXME
set(YCM_DOC_DIR ${CMAKE_INSTALL_DOCDIR})
set(YCM_MAN_DIR ${CMAKE_INSTALL_MANDIR})

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

add_subdirectory(modules)
add_subdirectory(find-modules)
add_subdirectory(cmake-next)
add_subdirectory(3rdparty)
add_subdirectory(deprecated)
add_subdirectory(build-modules)
add_subdirectory(style-modules)
add_subdirectory(docs)

# Use the new CMakePackageConfigHelpers from CMake repository in order to use
# the new ARCH_INDEPENDENT argument for write_basic_package_version_file
if(CMAKE_MINIMUM_REQUIRED_VERSION VERSION_GREATER_EQUAL 3.14)
    # Just a reminder to remove this when we change cmake version
    message(AUTHOR_WARNING "CMake minimum required version greater than 3.14. You can remove this.")
endif()
if(CMAKE_VERSION VERSION_LESS 3.14)
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake-next/v3.14")
endif()
include(CMakePackageConfigHelpers)

include(InstallBasicPackageFiles)
install_basic_package_files(YCM
                            VERSION ${YCM_VERSION}
                            COMPATIBILITY AnyNewerVersion
                            ARCH_INDEPENDENT
                            NO_EXPORT
                            EXTRA_PATH_VARS_SUFFIX MODULE_DIR
                            NO_CHECK_REQUIRED_COMPONENTS_MACRO)

include(AddUninstallTarget)

if(UNIX)
  # update-sha1sums target makes no sense on windows, since the .sh script
  # will fail to execute
  add_custom_target(update-sha1sums
                    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/tools/update_sha1sums.sh")
endif()

enable_testing()
include(CTest)

add_subdirectory(tests)

=== 3rdparty/CMakeLists.txt ===
#=============================================================================
# Copyright 2013-2019 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


option(YCM_NO_3RDPARTY "Disable 3rd party modules." FALSE)
mark_as_advanced(YCM_NO_3RDPARTY)

# Useful 3rd party modules
if(NOT YCM_NO_3RDPARTY OR YCM_MAINTAINER_MODE)

  include("${CMAKE_CURRENT_LIST_DIR}/eigen3.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/ovito.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/qt-gstreamer.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/cmake-wiki.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/catch2.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/vtk.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/qgv.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/cmrc.cmake")
  include("${CMAKE_CURRENT_LIST_DIR}/uselatex.cmake")

  # Print a warning if we are overriding some module from CMake
  file(GLOB_RECURSE _modules
       RELATIVE "${YCM_BINARY_DIR}/${YCM_INSTALL_MODULE_DIR}/3rdparty"
       "${YCM_BINARY_DIR}/${YCM_INSTALL_MODULE_DIR}/3rdparty/*.cmake")
  foreach(_module IN LISTS _modules)
    if(EXISTS "${CMAKE_ROOT}/Modules/${_module}")
      message(AUTHOR_WARNING "A \"${_module}\" module already exists in CMAKE_ROOT")
    endif()
  endforeach()

endif()

=== build-modules/CMakeLists.txt ===
#=============================================================================
# Copyright 2013-2015 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


set(YCM_BUILD_MODULES BuildECM.cmake
                      BuildGooCanvas.cmake
                      BuildGooCanvasMM.cmake
                      BuildGtkDatabox.cmake
                      BuildGtkDataboxMM.cmake
                      BuildTinyXML.cmake
                      BuildYARP.cmake
                      BuildICUB.cmake
                      BuildGazeboYARPPlugins.cmake
                      BuildEigen3.cmake
                      BuildqpOASES.cmake)

_ycm_install(build-modules FILES ${YCM_BUILD_MODULES}
                           DESTINATION "${YCM_INSTALL_MODULE_DIR}/build-modules")

# Print a warning if we are overriding some module from CMake
foreach(_module IN LISTS YCM_BUILD_MODULES)
  if(EXISTS "${CMAKE_ROOT}/Modules/${_module}")
    message(AUTHOR_WARNING "A \"${_module}\" module already exists in CMAKE_ROOT. Please remove it, or move it to proposed.")
  endif()
endforeach()

=== cmake-next/CMakeLists.txt ===
#=============================================================================
# Copyright 2013-2014 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


set(YCM_CMAKE_DOWNLOAD_URL "https://raw.githubusercontent.com/Kitware/CMake/<REF>/<FILE>"
    CACHE STRING "Url used to download CMake modules")
set_property(CACHE YCM_CMAKE_DOWNLOAD_URL PROPERTY
             STRINGS "https://raw.githubusercontent.com/Kitware/CMake/<REF>/<FILE>"
                     "http://cmake.org/gitweb?p=cmake.git\;a=blob_plain\;f=<FILE>\;hb=<REF>")
mark_as_advanced(YCM_CMAKE_DOWNLOAD_URL)

function(_YCM_CMAKE_NEXT_WRITE_README _ref _dir)
  file(WRITE "${_dir}/README"
"Files in this folder and its subfolder come from CMake git repository
(ref ${_ref}):

  git://cmake.org/cmake.git

They were imported exactly as they are on the original repository, in
order to supply the new features and bugfix available in newer releases
to user with older cmake releases.

These files are distributed under the OSI-approved BSD License;
see accompanying file Copyright.txt for details.
")
endfunction()

function(_YCM_CMAKE_NEXT_DOWNLOAD _ref _dir _files)
  _ycm_download(cmake-${_ref} "CMake git repository"
                "${YCM_CMAKE_DOWNLOAD_URL}"
                "${_ref}" "${_dir}" "${_files}")
  _ycm_cmake_next_write_readme(${_ref} "${_dir}")
endfunction()

function(_YCM_CMAKE_NEXT_INSTALL _ref)
  _ycm_install(cmake-${_ref} ${ARGN})
endfunction()

# Download and install files from CMake git at configure time, useful to
# download the modules used by the YCM build that are not available
# on older CMake versions
function(_YCM_CMAKE_NEXT_DOWNLOAD_NOW _ref _dir _files)
  # loop over a list of file and sha1
  list(LENGTH _files _size)
  foreach(_i RANGE 1 ${_size} 2)
    math(EXPR _j "${_i} - 1")
    list(GET _files ${_j} _file)
    list(GET _files ${_i} _sha1)

    string(REPLACE "<REF>" "${_ref}" _src "${YCM_CMAKE_DOWNLOAD_URL}")
    string(REPLACE "<FILE>" "${_file}" _src "${_src}")
    set(_dest "${_dir}/${_file}")
    set(_orig_dest "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/cmake-${_ref}.dir/downloads/${_file}")
    set(_offline_dest "${YCM_SOURCE_DIR}/downloads/cmake-${_ref}/${_file}")

    if(EXISTS "${_offline_dest}")
      execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different "${_offline_dest}" "${_orig_dest}")
    endif()

    if(NOT EXISTS "${_orig_dest}")
      message(STATUS "Downloading file ${_file} from CMake git repository (ref ${_ref})")
      file(DOWNLOAD "${_src}" "${_orig_dest}"
           EXPECTED_HASH SHA1=${_sha1})
    endif()

    if(WIN32)
      # On Windows we change files end of lines to the windows ones
      file(READ "${_orig_dest}" _tmp)
      string(REPLACE "/r/n" "/n" _tmp "${_tmp}")
      file(WRITE "${_dest}" "${_tmp}")
    else()
      execute_process(COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${_orig_dest}" "${_dest}")
    endif()

    execute_process(COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${_orig_dest}" "${_offline_dest}")

    set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${_dest})
  endforeach()
  _ycm_cmake_next_write_readme(${_ref} "${_dir}")
endfunction()


# Downloaded modules               CMake Version   Uncommitted
#                                                  Changes
#
#  FindDoxygen                      3.13
#  WriteBasicConfigVersionFile      3.14            Yes (CMAKE_ROOT)
#  FindSWIG                         3.14.7
#  UseSWIG                          3.14.7          Yes (Policies)
#  FindGLEW                         3.15
#  CMakeParseArguments              ---             Yes
#
# Changes in dependencies
#  FindPackageHandleStandardArgs

# NOTE: keep CMake version values listed at root/YCMConfig.cmake.in up
# to date with changes in the previous table.


################################################################################
# Files not available or containing bugs in CMake 3.12.4
# Imported from CMake tag v3.13.5
if(CMAKE_MINIMUM_REQUIRED_VERSION VERSION_GREATER_EQUAL 3.13)
  # Just a reminder to remove this when we change cmake version
  message(AUTHOR_WARNING "CMake minimum required version greater than 3.12. You can remove this.")
endif()

if(CMAKE_VERSION VERSION_LESS 3.13 OR YCM_MAINTAINER_MODE)

  set(_ref v3.13.5)
  set(_files Copyright.txt                               96563e603328872bc22d31a3445e23b438292751
             Modules/FindDoxygen.cmake                   5aa0b1f8cd5d4886da37fa8164be9d30bc196b82
             Modules/FindPackageHandleStandardArgs.cmake 97e455f2849eac8ef1449cba5e49064149bd2099  # Used by FindDoxygen
             Modules/FindPackageMessage.cmake            68bfe02f96faabad103d59811b324d82d7c1d178  # Used by FindPackageHandleStandardArgs
             Modules/CMakeParseArguments.cmake           eaf4dbce829d0eca5db28fc4b1a36b42f7948ad3) # Used by FindPackageHandleStandardArgs

  _ycm_cmake_next_download(v3.13.5 "${CMAKE_CURRENT_BINARY_DIR}/cmake-3.13" "${_files}")
  _ycm_cmake_next_install(v3.13.5 DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/cmake-3.13"
                                  DESTINATION "${YCM_INSTALL_MODULE_DIR}")
endif()


################################################################################
# Files not available or containing bugs in CMake 3.13.5
# Imported from CMake tag v3.14.7
if(CMAKE_MINIMUM_REQUIRED_VERSION VERSION_GREATER_EQUAL 3.14)
  # Just a reminder to remove this when we change cmake version
  message(AUTHOR_WARNING "CMake minimum required version greater than 3.13. You can remove this.")
endif()

# We assume that the user won't downgrade his CMake, therefore it's not
# necessary to download and install these files if already included in CMake
if(CMAKE_VERSION VERSION_LESS 3.14 OR YCM_MAINTAINER_MODE)

  set(_ref v3.14.7)
  set(_files Copyright.txt                                        ef5e9cd05a459b23263ecc409da2b3bc51aec2e4
             Modules/BasicConfigVersion-SameMajorVersion.cmake.in f89dc13283012256d1cb702ffb0bc235cee5cc5a
             Modules/BasicConfigVersion-SameMinorVersion.cmake.in a3e9f395d5ce5c66eb5b3fa8df2e9dfa8548562e
             Modules/BasicConfigVersion-ExactVersion.cmake.in     c723920559d6f22af6a7d5f10deb26b4c170773d
             Modules/BasicConfigVersion-AnyNewerVersion.cmake.in  fb0c14d1c39a46d856a18bec3430c45045f29a45
             Modules/CMakePackageConfigHelpers.cmake              e85b785df2000c4524b44ae735112f795dd2e219  # Required to be in the same folder as WriteBasicConfigVersionFile
             Modules/FindSWIG.cmake                               2ed683e758d9caa88f0b11f8814617c1179de3ce
             Modules/FindPackageHandleStandardArgs.cmake          97e455f2849eac8ef1449cba5e49064149bd2099  # Used by FindSWIG
             Modules/FindPackageMessage.cmake                     a3207b9d2996e4c5a2ecb254f9abf1e4ba037f0a  # Used by FindPackageHandleStandardArgs
             Modules/CMakeParseArguments.cmake                    79a086a72f0ea821e2587ac96df080703a614108) # Used by FindPackageHandleStandardArgs

  file(COPY v3.14/WriteBasicConfigVersionFile.cmake
            v3.14/UseSWIG.cmake
       DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/cmake-3.14/Modules")

  # The files CMakePackageConfigHelpers.cmake and
  # BasicConfigVersion-AnyNewerVersion.cmake.in are downloaded, but are also
  # used by WriteBasicConfigVersionFile in YCM main CMakeLists.txt, therefore
  # they should all be in the same directory (${_ref})

  _ycm_cmake_next_download(${_ref} "${CMAKE_CURRENT_BINARY_DIR}/cmake-3.14" "${_files}")
  _ycm_cmake_next_install(${_ref} DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/cmake-3.14"
                                  DESTINATION "${YCM_INSTALL_MODULE_DIR}")
endif()


################################################################################
# Files not available or containing bugs in CMake 3.14.7
# Imported from CMake tag v3.15.7
if(CMAKE_MINIMUM_REQUIRED_VERSION VERSION_GREATER_EQUAL 3.14)
  # Just a reminder to remove this when we change cmake version
  message(AUTHOR_WARNING "CMake minimum required version greater than 3.13. You can remove this.")
endif()

# We assume that the user won't downgrade his CMake, therefore it's not
# necessary to download and install these files if already included in CMake
if(CMAKE_VERSION VERSION_LESS 3.15 OR YCM_MAINTAINER_MODE)

  set(_ref v3.15.7)
  set(_files Copyright.txt                               ef5e9cd05a459b23263ecc409da2b3bc51aec2e4
             Modules/FindGLEW.cmake                      2eaf07f660491dd3db44b0801292f8dabb627ce0
             Modules/FindPackageHandleStandardArgs.cmake 97e455f2849eac8ef1449cba5e49064149bd2099  # Used by FindGLEW
             Modules/FindPackageMessage.cmake            a3207b9d2996e4c5a2ecb254f9abf1e4ba037f0a  # Used by FindPackageHandleStandardArgs
             Modules/CMakeParseArguments.cmake           79a086a72f0ea821e2587ac96df080703a614108  # Used by FindPackageHandleStandardArgs
             Modules/SelectLibraryConfigurations.cmake   423e51063f8df2286ca8a693c2cbc6c3e12ec61f) # Used by FindGLEW

  _ycm_cmake_next_download(${_ref} "${CMAKE_CURRENT_BINARY_DIR}/cmake-3.15" "${_files}")
  _ycm_cmake_next_install(${_ref} DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/cmake-3.15"
                                  DESTINATION "${YCM_INSTALL_MODULE_DIR}")
endif()



################################################################################
# Files not yet available or containing bugs in current CMake release (v3.15.7)
# Imported from latest revision tested

# None

# if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.16)
#     # Just a reminder to update files when a new cmake version is released
#     message(AUTHOR_WARNING "CMake version is ${CMAKE_VERSION}. You should update this.")
# endif()

# set(_ref f3ba8bf4024592fd7e09c1425258e67953839040)
# set(_files Copyright.txt                               ef5e9cd05a459b23263ecc409da2b3bc51aec2e4)
#
# _ycm_cmake_next_download(${_ref} "${CMAKE_CURRENT_BINARY_DIR}/cmake-next" "${_files}")
# _ycm_cmake_next_install(${_ref} DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/cmake-next"
#                                 DESTINATION "${YCM_INSTALL_MODULE_DIR}")


################################################################################
# Files with patches not yet merged in CMake master

# Always installed
set(YCM_CMAKE_PROPOSED_FILES proposed/ExternalProject.cmake
                             proposed/CMakeParseArguments.cmake)
set(YCM_CMAKE_PROPOSED_EXTRA_FILES  Copyright.txt # Must be redistributed together with CMake files
                                    README)       # Overwrite README generated by _ycm_cmake_next_download
_ycm_cmake_next_install(proposed FILES ${YCM_CMAKE_PROPOSED_FILES}
                                 DESTINATION "${YCM_INSTALL_MODULE_DIR}/cmake-proposed/Modules")
_ycm_cmake_next_install(proposed FILES ${YCM_CMAKE_PROPOSED_EXTRA_FILES}
                                 DESTINATION "${YCM_INSTALL_MODULE_DIR}/cmake-proposed")

=== deprecated/CMakeLists.txt ===
#=============================================================================
# Copyright 2013-2014 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


option(YCM_NO_DEPRECATED "Disable deprecated modules." FALSE)
mark_as_advanced(YARP_NO_DEPRECATED)

# Deprecated modules installed for compatibility
if(NOT YCM_NO_DEPRECATED)
  set(YCM_DEPRECATED_FILES YCMDefaultDirs.cmake)
  _ycm_install(deprecated FILES ${YCM_DEPRECATED_FILES}
                          DESTINATION "${YCM_INSTALL_MODULE_DIR}/deprecated")

  # Print a warning if we are overriding some module from CMake
  foreach(_module IN LISTS YCM_MODULES)
    if(EXISTS "${CMAKE_ROOT}/Modules/${_module}")
      message(AUTHOR_WARNING "A \"${_module}\" module already exists in CMAKE_ROOT. Please remove it, or move it to proposed.")
    endif()
  endforeach()

endif()

=== docs/CMakeLists.txt ===
#=============================================================================
# CMake - Cross Platform Makefile Generator
# Copyright 2000-2013 Kitware, Inc., Insight Software Consortium
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# if(NOT YCM_SOURCE_DIR)
#   set(CMakeHelp_STANDALONE 1)
#   cmake_minimum_required(VERSION 2.8.4 FATAL_ERROR)
#   get_filename_component(tmp "${CMAKE_CURRENT_SOURCE_DIR}" DIRECTORY)
#   get_filename_component(YCM_SOURCE_DIR "${tmp}" DIRECTORY)
#   include(${YCM_SOURCE_DIR}/Modules/CTestUseLaunchers.cmake)
#   include(${YCM_SOURCE_DIR}/Source/CMakeVersionCompute.cmake)
#   include(${YCM_SOURCE_DIR}/Source/CMakeInstallDestinations.cmake)
#   unset(CMAKE_DATA_DIR)
#   unset(CMAKE_DATA_DIR CACHE)
# endif()
project(YCMHelp NONE)

option(SPHINX_MAN "Build man pages with Sphinx" OFF)
option(SPHINX_HTML "Build html help with Sphinx" OFF)
option(SPHINX_SINGLEHTML "Build html single page help with Sphinx" OFF)
option(SPHINX_QTHELP "Build Qt help with Sphinx" OFF)
option(SPHINX_TEXT "Build text help with Sphinx (not installed)" OFF)
find_program(SPHINX_EXECUTABLE
  NAMES sphinx-build
  DOC "Sphinx Documentation Builder (sphinx-doc.org)"
  )

mark_as_advanced(SPHINX_EXECUTABLE
                 SPHINX_MAN
                 SPHINX_HTML
                 SPHINX_SINGLEHTML
                 SPHINX_QTHELP
                 SPHINX_TEXT)

if(NOT SPHINX_MAN AND NOT SPHINX_HTML AND NOT SPHINX_SINGLEHTML AND NOT SPHINX_QTHELP AND NOT SPHINX_TEXT)
  return()
elseif(NOT SPHINX_EXECUTABLE)
  message(FATAL_ERROR "SPHINX_EXECUTABLE (sphinx-build) is not found!")
endif()

# set(copyright_line_regex "^Copyright (2000-20[0-9][0-9] Kitware.*)")
# file(STRINGS "${YCM_SOURCE_DIR}/Copyright.txt" copyright_line
#   LIMIT_COUNT 1 REGEX "${copyright_line_regex}")
# if(copyright_line MATCHES "${copyright_line_regex}")
#   set(conf_copyright "${CMAKE_MATCH_1}")
# else()
#   set(conf_copyright "Kitware, Inc.")
# endif()

set(conf_copyright "Copyright 2013-2019 Istituto Italiano di Tecnologia (IIT)")

set(conf_docs "${YCM_SOURCE_DIR}/help")
set(conf_path "${CMAKE_CURRENT_SOURCE_DIR}")
set(conf_version "${YCM_VERSION_MAJOR}.${YCM_VERSION_MINOR}.${YCM_VERSION_TWEAK}")
set(conf_release "${YCM_VERSION}")
configure_file(conf.py.in conf.py @ONLY)

set(doc_formats "")
if(SPHINX_HTML)
  list(APPEND doc_formats html)
endif()
if(SPHINX_MAN)
  list(APPEND doc_formats man)
endif()
if(SPHINX_SINGLEHTML)
  list(APPEND doc_formats singlehtml)
endif()
if(SPHINX_TEXT)
  list(APPEND doc_formats text)
endif()
if(SPHINX_QTHELP)
  find_program(QCOLLECTIONGENERATOR_EXECUTABLE
    NAMES qcollectiongenerator
    DOC "qcollectiongenerator tool"
    )
  mark_as_advanced(QCOLLECTIONGENERATOR_EXECUTABLE)
  if (NOT QCOLLECTIONGENERATOR_EXECUTABLE)
    message(FATAL_ERROR "QCOLLECTIONGENERATOR_EXECUTABLE (qcollectiongenerator) not found!")
  endif()
  list(APPEND doc_formats qthelp)

  set(qthelp_extra_commands
    # Workaround for assistant prior to
    # https://codereview.qt-project.org/#change,82250 in Qt 4.
    COMMAND ${CMAKE_COMMAND} "-DCSS_DIR=${CMAKE_CURRENT_BINARY_DIR}/qthelp/_static"
      -P "${CMAKE_CURRENT_SOURCE_DIR}/apply_qthelp_css_workaround.cmake"
    # Workaround sphinx configurability:
    # https://bitbucket.org/birkenfeld/sphinx/issue/1448/make-qthelp-more-configurable
    COMMAND ${CMAKE_COMMAND} "-DQTHELP_DIR=${CMAKE_CURRENT_BINARY_DIR}/qthelp/"
      "-DYCM_VERSION=${YCM_VERSION_MAJOR}${YCM_VERSION_MINOR}"
      -P "${CMAKE_CURRENT_SOURCE_DIR}/fixup_qthelp_names.cmake"
    COMMAND qcollectiongenerator "${CMAKE_CURRENT_BINARY_DIR}/qthelp/YCM.qhcp"
  )
endif()


set(doc_format_outputs "")
set(doc_format_last "")
foreach(format ${doc_formats})
  set(doc_format_output "doc_format_${format}")
  set(doc_format_log "build-${format}.log")
  add_custom_command(
    OUTPUT ${doc_format_output}
    COMMAND ${SPHINX_EXECUTABLE}
            -c "${CMAKE_CURRENT_BINARY_DIR}"
            -d "${CMAKE_CURRENT_BINARY_DIR}/doctrees"
            -b ${format}
            "${YCM_SOURCE_DIR}/help"
            "${CMAKE_CURRENT_BINARY_DIR}/${format}"
            > ${doc_format_log} # log stdout, pass stderr
    ${${format}_extra_commands}
    DEPENDS ${doc_format_last}
    COMMENT "sphinx-build ${format}: see ${CMAKE_CURRENT_BINARY_DIR}/docs/${doc_format_log}"
    VERBATIM
    )
  set_property(SOURCE ${doc_format_output} PROPERTY SYMBOLIC 1)
  list(APPEND doc_format_outputs ${doc_format_output})
  set(doc_format_last ${doc_format_output})
endforeach()

add_custom_target(documentation ALL DEPENDS ${doc_format_outputs})

if(SPHINX_MAN)
  file(GLOB man_rst RELATIVE "${YCM_SOURCE_DIR}/help/manual"
    "${YCM_SOURCE_DIR}/help/manual/*.[1-9].rst")
  foreach(m ${man_rst})
    if("x${m}" MATCHES "^x(.+)\\.([1-9])\\.rst$")
      set(name "${CMAKE_MATCH_1}")
      set(sec "${CMAKE_MATCH_2}")
      install(FILES "${CMAKE_CURRENT_BINARY_DIR}/man/${name}.${sec}"
              DESTINATION "${YCM_MAN_DIR}/man${sec}")
    endif()
  endforeach()
endif()

if(SPHINX_HTML)
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html"
          DESTINATION "${YCM_DOC_DIR}"
          PATTERN .buildinfo EXCLUDE
          PATTERN objects.inv EXCLUDE
          )
endif()

if(SPHINX_SINGLEHTML)
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/singlehtml"
          DESTINATION "${YCM_DOC_DIR}"
          PATTERN .buildinfo EXCLUDE
          PATTERN objects.inv EXCLUDE
          )
endif()

if(SPHINX_QTHELP)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/qthelp/YCM-${YCM_VERSION_MAJOR}${YCM_VERSION_MINOR}.qch"
          DESTINATION "${YCM_DOC_DIR}"
          )
endif()

=== find-modules/CMakeLists.txt ===
#=============================================================================
# Copyright 2013-2014 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


set(YCM_FIND_MODULES FindACE.cmake
                     Findassimp.cmake
                     FindAtlas.cmake
                     FindCFW2CANAPI.cmake
                     FindDRAGONFLYAPI.cmake
                     FindESDCANAPI.cmake
                     FindFreenect.cmake
                     FindFTDI.cmake
                     FindFuse.cmake
                     FindGLFW3.cmake
                     FindGLM.cmake
                     FindGLUT.cmake
                     FindGooCanvas.cmake
                     FindGooCanvasMM.cmake
                     FindGSL.cmake
                     FindGtkDatabox.cmake
                     FindGtkDataboxMM.cmake
                     FindI2C.cmake
                     FindIPOPT.cmake
                     FindIPP.cmake
                     FindLibdc1394.cmake
                     FindLibedit.cmake
                     FindLibOVR.cmake
                     FindLibusb1.cmake
                     FindLibv4l2.cmake
                     FindLibv4lconvert.cmake
                     FindNVIDIACg.cmake
                     FindODE.cmake
                     FindOpenCV.cmake
                     FindOpenGL.cmake
                     FindOpenNI.cmake
                     FindOpenNI2.cmake
                     FindPLXCANAPI.cmake
                     FindPortAudio.cmake
                     FindqpOASES.cmake
                     FindReadline.cmake
                     FindSQLite.cmake
                     FindStage.cmake
                     FindTinyXML.cmake
                     FindYamlCpp.cmake
                     FindZFP.cmake)

_ycm_install(find-modules FILES ${YCM_FIND_MODULES}
                          DESTINATION "${YCM_INSTALL_MODULE_DIR}/find-modules")

# Print a warning if we are overriding some module from CMake
foreach(_module IN LISTS YCM_FIND_MODULES)
  if(EXISTS "${CMAKE_ROOT}/Modules/${_module}")
    message(AUTHOR_WARNING "A \"${_module}\" module already exists in CMAKE_ROOT. Please remove it, or move it to proposed.")
  endif()
endforeach()

=== modules/CMakeLists.txt ===
#=============================================================================
# Copyright 2013-2014 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


set(YCM_MODULES AddInstallRPATHSupport.cmake
                AddUninstallTarget.cmake
                ExtractVersion.cmake
                FindOrBuildPackage.cmake
                GetAllCMakeProperties.cmake
                GitInfo.cmake
                IncludeUrl.cmake
                InstallBasicPackageFiles.cmake
                ReplaceImportedTargets.cmake
                StandardFindModule.cmake
                YCMEPHelper.cmake)

_ycm_install(modules FILES ${YCM_MODULES}
                     DESTINATION "${YCM_INSTALL_MODULE_DIR}/modules")

# Print a warning if we are overriding some module from CMake
foreach(_module IN LISTS YCM_MODULES)
  if(EXISTS "${CMAKE_ROOT}/Modules/${_module}")
    message(AUTHOR_WARNING "A \"${_module}\" module already exists in CMAKE_ROOT. Please remove it, or move it to proposed.")
  endif()
endforeach()

=== style-modules/CMakeLists.txt ===
#=============================================================================
# Copyright 2017 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


set(YCM_STYLE_MODULES StyleBITBUCKET.cmake
                      StyleGITHUB.cmake
                      StyleGITLAB_ROBOTOLOGY.cmake
                      StyleGNOME.cmake
                      StyleKDE.cmake
                      StyleLOCAL.cmake
                      StyleNONE.cmake
                      StyleSOURCEFORGE.cmake)

_ycm_install(style-modules FILES ${YCM_STYLE_MODULES}
                           DESTINATION "${YCM_INSTALL_MODULE_DIR}/style-modules")

# Print a warning if we are overriding some module from CMake
foreach(_module IN LISTS YCM_STYLE_MODULES)
  if(EXISTS "${CMAKE_ROOT}/Modules/${_module}")
    message(AUTHOR_WARNING "A \"${_module}\" module already exists in CMAKE_ROOT. Please remove it, or move it to proposed.")
  endif()
endforeach()

=== tests/CMakeLists.txt ===
#=============================================================================
# Copyright 2000-2014 Kitware, Inc.
# Copyright 2000-2011 Insight Software Consortium
# Copyright 2014 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)


# Set up test-time configuration.
set_directory_properties(PROPERTIES TEST_INCLUDE_FILE "${CMAKE_CURRENT_BINARY_DIR}/EnforceConfig.cmake")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/EnforceConfig.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/EnforceConfig.cmake @ONLY)

macro(ADD_TEST_MACRO NAME COMMAND)
  string(REPLACE "." "/" dir "${NAME}")
  string(REGEX REPLACE "[^.]*\\." "" proj "${NAME}")
  add_test(${NAME} ${CMAKE_CTEST_COMMAND}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/${dir}"
    "${CMAKE_CURRENT_BINARY_DIR}/${dir}"
    --build-two-config
    ${build_generator_args}
    ${build_makeprogram_args}
    --build-project ${proj}
    ${${NAME}_CTEST_OPTIONS}
    --build-options ${build_options}
    ${${NAME}_BUILD_OPTIONS}
    --test-command ${COMMAND} ${ARGN})
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR}/${dir}")
endmacro()

# Fake a user home directory to avoid polluting the real one.
if(DEFINED ENV{HOME} AND NOT CTEST_NO_TEST_HOME)
  set(TEST_HOME "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/TestHome")
  file(MAKE_DIRECTORY "${TEST_HOME}")
endif()

# Choose a default configuration for CTest tests.
set(CTestTest_CONFIG Debug)
if(NOT CMAKE_CONFIGURATION_TYPES AND CMAKE_BUILD_TYPE)
  set(CTestTest_CONFIG ${CMAKE_BUILD_TYPE})
endif()

# Testing
if(BUILD_TESTING)
  set(YCM_TEST_DEVENV "")
  if(CMAKE_GENERATOR MATCHES "Visual Studio [7-9] " AND
      NOT CMAKE_MAKE_PROGRAM MATCHES "[mM][sS][bB][uU][iI][lL][dD]\\.[eE][xX][eE]")
    set(YCM_TEST_DEVENV "${CMAKE_MAKE_PROGRAM}")
  endif()

  set(YCM_TEST_EXPLICIT_MAKE_PROGRAM "${CMAKE_MAKE_PROGRAM}")

  if(NOT YCM_TEST_EXTERNAL_CMAKE)
    if("${CMAKE_GENERATOR}" MATCHES "Unix Makefiles" OR ("${CMAKE_GENERATOR}" MATCHES Ninja AND NOT WIN32))
      set(TEST_CompileCommandOutput 1)
    endif()
  endif()

  set(MAKE_IS_GNU )
  if(CMAKE_MAKE_PROGRAM MATCHES make)
    execute_process(COMMAND ${CMAKE_MAKE_PROGRAM} no_such_target --version
      RESULT_VARIABLE res OUTPUT_VARIABLE out ERROR_VARIABLE out)
    if("${res}" STREQUAL "0")
      if("${out}" MATCHES "GNU")
        set(MAKE_IS_GNU 1)
      endif()
    endif()
  endif()

  # some old versions of make simply cannot handle spaces in paths
  if (MAKE_IS_GNU OR
      CMAKE_MAKE_PROGRAM MATCHES "nmake|gmake|wmake" OR
      CMAKE_GENERATOR MATCHES "Visual Studio|Xcode|Borland")
    set(MAKE_SUPPORTS_SPACES 1)
  else()
    set(MAKE_SUPPORTS_SPACES 0)
  endif()

  set(build_generator_args
    --build-generator ${CMAKE_GENERATOR}
    )
  if(CMAKE_GENERATOR_TOOLSET)
    list(APPEND build_generator_args
      --build-generator-toolset ${CMAKE_GENERATOR_TOOLSET}
      )
  endif()

  set(build_options)
  if(YCM_TEST_EXPLICIT_MAKE_PROGRAM)
    list(APPEND build_options -DCMAKE_MAKE_PROGRAM:FILEPATH=${YCM_TEST_EXPLICIT_MAKE_PROGRAM})
  endif()

  set(build_makeprogram_args
    --build-makeprogram ${YCM_TEST_EXPLICIT_MAKE_PROGRAM}
    )

  if(NOT WIN32)
    # sha1sums test is disabled on Windows, because it is an sh script
    add_test(NAME sha1sums
             WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/sha1sums"
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/sha1sums/check_sha1sums.sh ${YCM_SOURCE_DIR}/modules/YCMEPHelper.cmake)
  endif()

  add_test(YCMBootstrap-not-found ${CMAKE_CTEST_COMMAND}
           --build-and-test
           "${CMAKE_CURRENT_SOURCE_DIR}/YCMBootstrap"
           "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-not-found"
           ${build_generator_args}
           ${build_makeprogram_args}
           --build-project YCMBootstrap
           --build-option "-DYCM_BOOTSTRAP_TEST:STRING=NOT_FOUND")
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-not-found")

  add_test(YCMBootstrap-build-dir ${CMAKE_CTEST_COMMAND}
           --build-and-test
           "${CMAKE_CURRENT_SOURCE_DIR}/YCMBootstrap"
           "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-build-dir"
           ${build_generator_args}
           ${build_makeprogram_args}
           --build-project YCMBootstrap
           --build-options "-DYCM_BOOTSTRAP_TEST:STRING=BUILD_DIR")
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-build-dir")

  add_test(YCMBootstrap-install-dir ${CMAKE_CTEST_COMMAND}
           --build-and-test
           "${CMAKE_CURRENT_SOURCE_DIR}/YCMBootstrap"
           "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-install-dir"
           ${build_generator_args}
           ${build_makeprogram_args}
           --build-project YCMBootstrap
           --build-options "-DYCM_BOOTSTRAP_TEST:STRING=INSTALL_DIR")
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-install-dir")
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/TestPrefix")

  add_test(YCMBootstrap-not-use-system ${CMAKE_CTEST_COMMAND}
           --build-and-test
           "${CMAKE_CURRENT_SOURCE_DIR}/YCMBootstrap"
           "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-not-use-system"
           ${build_generator_args}
           ${build_makeprogram_args}
           --build-project YCMBootstrap
           --build-options "-DYCM_BOOTSTRAP_TEST:STRING=NOT_USE_SYSTEM")
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-not-use-system")

  add_test(YCMBootstrap-disable-find ${CMAKE_CTEST_COMMAND}
           --build-and-test
           "${CMAKE_CURRENT_SOURCE_DIR}/YCMBootstrap"
           "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-disable-find"
           ${build_generator_args}
           ${build_makeprogram_args}
           --build-project YCMBootstrap
           --build-options "-DYCM_BOOTSTRAP_TEST:STRING=DISABLE_FIND")
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR}/YCMBootstrap-disable-find")

  # Add download folder to the list of files deleted by test_clean
  list(APPEND TEST_BUILD_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/YCMBootstrap/external")

  if(NOT EXISTS "${YCM_BINARY_DIR}/CMakeLists.txt")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/test_clean.cmake.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/test_clean.cmake" @ONLY)
    add_custom_target(test_clean
      COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/test_clean.cmake"
      COMMENT "Removing test build directories."
      )
  endif()

  if(CMAKE_GENERATOR MATCHES "Visual Studio|Xcode")
    set(CMake_TEST_EXPLICIT_MAKE_PROGRAM "")
  else()
    set(CMake_TEST_EXPLICIT_MAKE_PROGRAM "${CMAKE_MAKE_PROGRAM}")
  endif()

  set(CMAKE_CMAKE_COMMAND "${CMAKE_COMMAND}")

  add_subdirectory(RunCMake)

endif()

=== tests/RunCMake/CMakeLists.txt ===
# See adjacent README.rst for documentation of this test infrastructure.
macro(add_RunCMake_test test)
  set(TEST_ARGS ${ARGN})
  if ("${ARGV1}" STREQUAL "TEST_DIR")
    if ("${ARGV2}" STREQUAL "")
      message(FATAL_ERROR "Invalid args")
    endif()
    set(Test_Dir ${ARGV2})
    list(REMOVE_AT TEST_ARGS 0)
    list(REMOVE_AT TEST_ARGS 0)
  else()
    set(Test_Dir ${test})
  endif()
  add_test(NAME RunCMake.${test} COMMAND ${CMAKE_CMAKE_COMMAND}
    -DCMAKE_MODULE_PATH=${CMAKE_CURRENT_SOURCE_DIR}
    -DYCM_SOURCE_DIR=${YCM_SOURCE_DIR}
    -DYCM_BINARY_DIR=${YCM_BINARY_DIR}
    -DRunCMake_GENERATOR=${CMAKE_GENERATOR}
    -DRunCMake_GENERATOR_PLATFORM=${CMAKE_GENERATOR_PLATFORM}
    -DRunCMake_GENERATOR_TOOLSET=${CMAKE_GENERATOR_TOOLSET}
    -DRunCMake_MAKE_PROGRAM=${CMake_TEST_EXPLICIT_MAKE_PROGRAM}
    -DRunCMake_MODULE_PATH=${YCM_SOURCE_DIR}/modules
    -DRunCMake_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}/${Test_Dir}
    -DRunCMake_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}/${test}
    ${${test}_ARGS}
    ${TEST_ARGS}
    -P "${CMAKE_CURRENT_SOURCE_DIR}/${Test_Dir}/RunCMakeTest.cmake"
    )
endmacro()

function(add_RunCMake_test_group test types)
  # create directory for common content
  set(TEST_CONFIG_DIR "${CMAKE_CURRENT_BINARY_DIR}/${test}/conf")
  file(REMOVE_RECURSE "${TEST_CONFIG_DIR}")
  file(MAKE_DIRECTORY "${TEST_CONFIG_DIR}")

  foreach(type IN LISTS types)
    # generate prerequirements config file in cmake as ctest doesn't have as
    # much system information so it is easier to set programs and environment
    # values here
    unset(${test}_${type}_FOUND_PREREQUIREMENTS)
    include("${CMAKE_CURRENT_SOURCE_DIR}/${test}/${type}/Prerequirements.cmake")
    get_test_prerequirements("${test}_${type}_FOUND_PREREQUIREMENTS"
        "${TEST_CONFIG_DIR}/${type}_config.cmake")

    # only add the test if prerequirements are met
    if(${test}_${type}_FOUND_PREREQUIREMENTS)
      add_test(NAME RunCMake.${test}_${type} COMMAND ${CMAKE_CMAKE_COMMAND}
        -DTEST_TYPE=${type}
        -DCMAKE_MODULE_PATH=${CMAKE_CURRENT_SOURCE_DIR}
        -DYCM_SOURCE_DIR=${YCM_SOURCE_DIR}
        -DRunCMake_GENERATOR=${CMAKE_GENERATOR}
        -DRunCMake_GENERATOR_PLATFORM=${CMAKE_GENERATOR_PLATFORM}
        -DRunCMake_GENERATOR_TOOLSET=${CMAKE_GENERATOR_TOOLSET}
        -DRunCMake_MAKE_PROGRAM=${CMake_TEST_EXPLICIT_MAKE_PROGRAM}
        -DRunCMake_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}/${test}
        -DRunCMake_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}/${type}/${test}
        -Dconfig_file=${TEST_CONFIG_DIR}/${type}_config.cmake
        -P "${CMAKE_CURRENT_SOURCE_DIR}/${test}/RunCMakeTest.cmake"
        )
    endif()
  endforeach()
endfunction()

add_RunCMake_test(AddInstallRPATHSupport)
add_RunCMake_test(IncludeUrl)
add_RunCMake_test(cmake-next)
add_RunCMake_test(3rdparty)

=== tests/YCMBootstrap/CMakeLists.txt ===
#=============================================================================
# Copyright 2014 Istituto Italiano di Tecnologia (IIT)
#   Authors: Daniele E. Domenichelli <daniele.domenichelli@iit.it>
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
# (To distribute this file outside of YCM, substitute the full
#  License text for the above reference.)

cmake_minimum_required(VERSION 3.12)
project(YCMbootstrap NONE)

include(FeatureSummary)

set(CMAKE_PREFIX_PATH )
set(ENV{CMAKE_PREFIX_PATH} )

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_BINARY_DIR}/cmake")

get_filename_component(YCM_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../" REALPATH)
get_filename_component(YCM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/../../" REALPATH)

file(COPY "${YCM_SOURCE_DIR}/tools/YCMBootstrap.cmake"
          "${YCM_SOURCE_DIR}/modules/IncludeUrl.cmake"
          DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/cmake")

# Download files from local file system
set(YCM_BOOTSTRAP_BASE_ADDRESS file://${YCM_SOURCE_DIR} CACHE STRING "Base address of YCM repository")

if(EXISTS "${YCM_SOURCE_DIR}/.git")
    find_package(Git REQUIRED)
    execute_process(COMMAND "${GIT_EXECUTABLE}" rev-list --max-count=1 HEAD
                    WORKING_DIRECTORY ${YCM_SOURCE_DIR}
                    RESULT_VARIABLE error_code
                    OUTPUT_VARIABLE head_sha
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(NOT error_code)
        set(YCM_TAG "${head_sha}")
    endif()

    if(NOT EXISTS "${YCM_SOURCE_DIR}/.git/shallow")
        # This is a proper git repo, we can clone from it.
        set(YCM_STYLE LOCAL)
        set(YCM_REPOSITORY file://${YCM_SOURCE_DIR})

        if(EXISTS "${YCM_SOURCE_DIR}/downloads")
            # Perform initial clone and copy downloads folder to avoid multiple
            # downloads.
            execute_process(COMMAND ${GIT_EXECUTABLE} clone "${YCM_REPOSITORY}" "external/YCM"
                            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

            file(COPY "${YCM_SOURCE_DIR}/downloads"
                 DESTINATION "${CMAKE_CURRENT_SOURCE_DIR}/external/YCM/")
        endif()
    endif()
else()
    message("Not a git repository")
endif()


if(NOT DEFINED YCM_TAG)
    set(YCM_TAG "v${YCM_VERSION_MAJOR}.${YCM_VERSION_MINOR}.${YCM_VERSION_PATCH}")
endif()

message("Using YCM_TAG = \"${YCM_TAG}\"")
message("Using YCM_STYLE = \"${YCM_STYLE}\"")
message("Using YCM_REPOSITORY = \"${YCM_REPOSITORY}\"")

set(YCM_BOOTSTRAP_VERBOSE TRUE)
set(NON_INTERACTIVE_BUILD TRUE)

if(YCM_BOOTSTRAP_TEST STREQUAL "BUILD_DIR")
    set(YCM_DIR ${YCM_BINARY_DIR} CACHE PATH "")
elseif(YCM_BOOTSTRAP_TEST STREQUAL "INSTALL_DIR")
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build")
    execute_process(COMMAND ${CMAKE_COMMAND} ${YCM_SOURCE_DIR} -DCMAKE_INSTALL_PREFIX=${YCM_BINARY_DIR}/tests/CMakeFiles/TestPrefix
                    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_CURRENT_BINARY_DIR}/build
                    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_CURRENT_BINARY_DIR}/build --target install
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build
                    OUTPUT_QUIET
                    ERROR_QUIET)
    list(APPEND CMAKE_PREFIX_PATH "${YCM_BINARY_DIR}/tests/CMakeFiles/TestPrefix")
elseif(YCM_BOOTSTRAP_TEST STREQUAL "NOT_USE_SYSTEM")
    set(YCM_DIR ${YCM_BINARY_DIR} CACHE PATH "")
    set(USE_SYSTEM_YCM FALSE)
elseif(YCM_BOOTSTRAP_TEST STREQUAL "DISABLE_FIND")
    set(YCM_DIR ${YCM_BINARY_DIR} CACHE PATH "")
    set(CMAKE_DISABLE_FIND_PACKAGE_YCM TRUE)
endif()

include(YCMBootstrap)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES)

=== debian/changelog ===
ycm-cmake-modules (0.12.1-1) unstable; urgency=medium

  * New upstream release (0.12.1)

 -- Daniele E. Domenichelli <ddomenichelli@drdanz.it>  Fri, 15 Jan 2021 12:11:40 +0100

ycm-cmake-modules (0.12.0-1) unstable; urgency=medium

  * Initial release (Closes: #934757)

 -- Daniele E. Domenichelli <ddomenichelli@drdanz.it>  Thu, 29 Oct 2020 17:20:06 +0100

=== debian/control ===
Source: ycm-cmake-modules
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Daniele E. Domenichelli <ddomenichelli@drdanz.it>
Build-Depends:
 debhelper-compat (= 13),
 dh-linktree,
 cmake (>= 3.12),
 python3-sphinx,
 libjs-sphinxdoc (>= 2.4.3-5),
 python3-sphinxcontrib.autoprogram,
 python3-sphinxcontrib.qthelp
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/ycm-cmake-modules
Vcs-Git: https://salsa.debian.org/science-team/ycm-cmake-modules.git
Homepage: https://robotology.github.io/ycm/
Rules-Requires-Root: no

Package: ycm-cmake-modules
Architecture: all
Depends: ${misc:Depends}, cmake (>= 3.12)
Description: Extra CMake Modules for YARP and friends
 The package YCM contains a set of CMake files that support creation and
 maintenance of repositories and software packages. YCM has been written
 with the aim of solving some of the problems encountered while managing
 large research projects but it can be used outside it initial context.
 .
 YCM is not a replacement to CMake or yet another build system. YCM is
 just a thin layer over CMake. It does not add extra dependencies like
 other build systems, it does not use Python, Ruby, or other scripting
 languages, it is written using CMake language. It is a collection of
 CMake modules, most of them candidate for being contributed upstream.
